var ModelValueConstructor_1;
import { __decorate } from "tslib";
import { apiValueConstructor } from '@a11d/api';
import '@a11d/is-writable';
export const model = (typeName) => {
    return (Constructor) => {
        ModelValueConstructor.modelConstructorsByTypeName.set(typeName, Constructor);
        // @ts-expect-error - ModelValueConstructor.typeNameKey is not typed
        Constructor[ModelValueConstructor.typeNameKey] = typeName;
    };
};
let ModelValueConstructor = ModelValueConstructor_1 = class ModelValueConstructor {
    constructor() {
        this.shallConstruct = (value) => !!value && typeof value === 'object' && ModelValueConstructor_1.typeNameKey in value;
    }
    construct(object) {
        const typeName = object[ModelValueConstructor_1.typeNameKey];
        const Constructor = ModelValueConstructor_1.modelConstructorsByTypeName.get(typeName);
        return !Constructor ? object : safeAssign(new Constructor, object);
    }
};
ModelValueConstructor.modelConstructorsByTypeName = new Map();
ModelValueConstructor.typeNameKey = '@type';
ModelValueConstructor = ModelValueConstructor_1 = __decorate([
    apiValueConstructor()
], ModelValueConstructor);
export { ModelValueConstructor };
function safeAssign(target, source) {
    for (const [key, value] of Object.entries(source)) {
        if (Object.isWritable(target, key)) {
            target[key] = value;
        }
    }
    return target;
}
